//----------------------------------------------------
//
// File:   utilpanl.h
// Author: Patrice BERNARD (metro@nanika.net)
//
// Preference panel management declarations
//
//----------------------------------------------------
//
// Version 1.0.0 (12/03/2005)
// - Creation
//
//----------------------------------------------------
//
// USAGE
//
// Resources (main panel description)
// ---------
//
// FORM ID ID_FORM_MAIN AT (0 0 160 160)
// NOFRAME
// NOSAVEBEHIND
// USABLE
// DEFAULTBTNID ID_BUTN_CLOS
// BEGIN
// 	TITLE "TITLE"
//
// 	POPUPTRIGGER ""       ID ID_TRIG_PANL AT (RIGHT@159 1 AUTO AUTO)    USABLE RIGHTANCHOR
// 	LIST         ""       ID ID_LIST_PANL AT (PREVLEFT PREVTOP 55 AUTO) NONUSABLE VISIBLEITEMS 1
// 	POPUPLIST             ID ID_TRIG_PANL ID_LIST_PANL
// 	LABEL        "APPNM"  ID ID_LABL_TITL AT (RIGHT@159 1)              NONUSABLE
//
//
// 	BUTTON       "BTEND"  ID ID_BUTN_CLOS AT (2 144 AUTO AUTO)          NONUSABLE FRAME
// END
//
// "APPNM" is the app name and "BTEND" is the close button title
//
//
// Resources identifiers (in resources.rh)
// ---------------------
//
// // Values may be changed (identifiers may not)
// #define ID_FORM_MAIN      1001
// #define ID_TRIG_PANL      1200
// #define ID_LIST_PANL      1201
// #define ID_LABL_TITL      1400
// #define ID_BUTN_CLOS      1600
//
//
// Code
// ----
// In PilotMain(), check launch code:
//
// case sysAppLaunchCmdNormalLaunch:
// case sysAppLaunchCmdPanelCalledFromApp:
// case sysAppLaunchCmdReturnFromPanel:
// // Register call mode (pass application creator ID)
// PanelSetCallMode(cmd == sysAppLaunchCmdPanelCalledFromApp, AppCreatorID);
// // Run application as usual
//
// In main form handler
// - frmOpenevent: call PanelFormInit(form)
// - popSelectEvent: call PanelSelectPanel(event)
// - ctlSelectEvent: call PanelSelectClose(event)
// - frmCloseEvent: call PanelFormClose()
//
//----------------------------------------------------

// Register whether launched in pref panel mode or from an app
// Changes the UI accordingly
void    PanelSetCallMode(UInt16 callMode, UInt32 crid);

// Initialize the form depending on the launch mode
// (panel pick list / close button)
void    PanelFormInit(FormPtr form);

// Close the form (memory cleaning required)
void    PanelFormClose(void);

// Panel list selection processing
// Switch to another panel
// Returns true if the selection occured in the panel list
Boolean PanelSelectPanel(EventType * event);

// Close button processing
// Closes the panel form and application
// Returns true if the control was the "Close" button
Boolean PanelSelectClose(EventType * event);
